<?

/*   parse.inc for search.php3
 *   (C) 1999,2000 by Sergey Kartashoff aka gluke,
 *                    UdmSearch Developers Team
 */

// -----------------------------------------------
// ParseStr($qwe)
// -----------------------------------------------
function ParseStr($qwe){

  $qwe=ereg_replace("[^ &|~()ţ0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ]{1,}","&",$qwe);
  $qwe=ereg_replace("^ {0,}","",$qwe);
  $qwe=ereg_replace(" {0,}\| {0,}","|",$qwe);
  $qwe=ereg_replace(" {0,}\& {0,}","&",$qwe);
  $qwe=ereg_replace(" {0,}\( {0,}","(",$qwe);
  $qwe=ereg_replace(" {0,}\) {0,}",")",$qwe);
  $qwe=ereg_replace(" {0,}\~ {0,}","~",$qwe);
  $qwe=ereg_replace(" {1,}","|",$qwe);
  $qwe=ereg_replace("\|{1,}","|",$qwe);
  $qwe=ereg_replace("&{1,}","&",$qwe);  
  $qwe=ereg_replace("\|\&\|","&",$qwe);
  $qwe=ereg_replace("[\|\&]{1,}$","",$qwe);
  $qwe=ereg_replace("^[\|\&]{1,}","",$qwe);

  return($qwe);
}

// -----------------------------------------------
// ParseQ($q)
// -----------------------------------------------
function ParseQ($q){
   if (ereg_replace(" ","",$q)==''){
       print_template('bottom');
       exit;
   }               
   
   $q=ParseStr($q);
   
   $q=ereg_replace("\&"," && ",$q);
   $q=ereg_replace("\|"," || ",$q);
   $q=ereg_replace("\~"," ! ",$q);
   $q=ereg_replace("\("," ( ",$q);
   $q=ereg_replace("\)"," ) ",$q);
   $q="( $q )"; 
   $q=ereg_replace(" {1,}"," ",$q);

   return $q;
}

// -----------------------------------------------
// last_parse($q)
// -----------------------------------------------
function last_parse($q){
   global $stopwords;
   global $dbtype;
   global $dbmode;
   global $ul, $ue, $uestr, $ulstr;
   global $tagstr;
   global $DEBUG;
   global $temp_table;
   global $final_word;
   global $ispellmode;

   $state=0;
   $qu="";
   $w=""; 
   $n=0;
   $t=strtok($q," ");
   $words=array();
   
   while(($t!="")&&($error=="")){
     if(isset($stopwords[$t])) {
       $t='';
     }
   
     switch($state){
       case 0;  
       if(($t=="||")||($t=="&&")||($t==")")) $error="at '$t'";
       else if($t=="!") { 
         $state=0;
         $qu="$qu NOT "; break;
       }
       else if($t=="("){
         $n++;
         $state=0;
         $qu="$qu(";
       }
       else {
         normalize_word($t);
         $words[]=$t;
         $qu="$qu %$t% ";
         $state=1;
       }
       break;
       
       case 1;  
       if(($t=="||")||($t=="&&")){
         $state=0;
         if ($t=='||') $qu="$qu OR ";
         else $qu="$qu AND ";
       }
       else if($t==")") {
         $n--;
         $state=1;
         $qu="$qu)";
       }
       else
         $error=" at '$t'";
       break;
     }
     $t=strtok(" ");
   }
   
   if($error=="" && $n != 0) $error='Unmatched brackets';
   if($error!="") print_error_local($error);

   if (eregi('db',$ispellmode) || eregi('text',$ispellmode)) check_words();

   for ($i=0; $i<count($words); $i++) {
      $word=$words[$i];
      $qu_norm='';

      for ($j=0; $j<count($final_word["$word"]); $j++) {
         $norm_word=$final_word["$word"][$j];
         switch ($dbtype) {
            case 'mysql' : $qu_norm .= " sum(word='$norm_word')>0 OR "; break;
	    case 'oracle7':
	    case 'oracle8':
            case 'oracle': $qu_norm .= " sum(decode(word,'$norm_word',1,0))>0 OR "; break;
            case 'pgsql' : $qu_norm .= " sum(case word when '$norm_word' then 1 else 0 end)>0 OR "; break;
            default      : $qu_norm .= " sum(word='$norm_word')>0 OR "; break;
         } 
         if($w=="") $w="'$norm_word'"; else $w .=",'$norm_word'";
      }

      $qu_norm="($qu_norm)";
      $qu_norm=str_replace("OR )",")",$qu_norm);
      $qu=str_replace("%$word%",$qu_norm,$qu);
   }

   if (($dbtype == 'mysql') || ($dbtype == '')) $sql_small = 'SQL_SMALL_RESULT';

   if ($dbmode == 'multi') {
// ------------------
// DBMode = multi
      $query="";

      if ($dbtype == 'pgsql') {
      	 $make_temp_table=1;
      	 $temp_table = 't'.time().rand(1000000,9999999);
      } else {
         $make_temp_table=0;
         $temp_table="";
      }

      for ($i=0; $i<count($words); $i++) {
         $word=$words[$i];
         $qu_norm='';

         for ($j=0; $j<count($final_word["$word"]); $j++) {
            $norm_word=$final_word["$word"][$j];

            $dict=get_dict_tab($norm_word);

            if ($query=="") {
               if ($make_temp_table == 0) {
                  $query="SELECT url_id,word,intag
                            FROM $dict
                           WHERE word in ('$norm_word')";
               } else {
                  $query="SELECT url_id,word,intag
                            INTO TEMP $temp_table
                            FROM $dict
                           WHERE word in ('$norm_word')";
               }
            } else {
               $query.=" UNION ALL
                        SELECT url_id,word,intag
                          FROM $dict
                         WHERE word in ('$norm_word')";
            }
        }
      }

      if ($make_temp_table == 1) {
         if($DEBUG) echo $query,"<BR><HR>";
         if (!($temp_table_res=query($query))) print_error_local('Query error: '.$query."\n<BR>".db_error());;
         free_result($temp_table_res);
      }

      if($ulstr||$uestr||$tagstr) {
         if (($dbtype == 'oracle') || 
	     ($dbtype == 'oracle7') ||
	     ($dbtype == 'oracle8')) {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
                                  FROM url, ($query) 
             	                 WHERE url.rec_id=url_id 
                                   $ulstr
                                   $uestr
             	                   $tagstr 
             	                 GROUP BY url_id 
             	             HAVING ($qu)
             	              ORDER BY r DESC";
           
                 $query_count_url_id="SELECT count(*)
                                        FROM (
                                           SELECT url_id
                                             FROM url, ($query) 
                      	                    WHERE url.rec_id=url_id 
                      	                      $ulstr
                                              $uestr
                      	                      $tagstr 
                      	                    GROUP BY url_id
                      	                   HAVING ($qu)
                                        )";

         } elseif ($dbtype == 'pgsql') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
                                  FROM url, $temp_table 
             	                 WHERE url.rec_id=url_id 
             	                   $ulstr
                                   $uestr
             	                   $tagstr 
             	                 GROUP BY url_id 
             	             HAVING ($qu)
             	              ORDER BY r DESC";
           
                 $query_count_url_id="";
         }
      } else {
         // not ul,ue nor tagstr
         if (($dbtype == 'oracle')||
	     ($dbtype == 'oracle7') ||
	     ($dbtype == 'oracle8')) {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
             	                  FROM ($query) 
             	                 GROUP BY url_id 
             	                HAVING ($qu)
             	                 ORDER BY r DESC";
           
                 $query_count_url_id="SELECT count(*)
                                        FROM (
             	                           SELECT url_id
             	                             FROM ($query) 
             	                            WHERE word in ($w)
             	                            GROUP BY url_id 
             	                           HAVING ($qu)
             	                        )";
         } elseif ($dbtype == 'pgsql') {
                 $query_url_id="SELECT url_id,
                                       sum(intag) as r 
             	                  FROM $temp_table 
             	                 GROUP BY url_id 
             	                HAVING ($qu)
             	                 ORDER BY r DESC";
           
                 $query_count_url_id="";
         }
      }

   } else {
// ------------------
// DBMode = single 

      if($ulstr||$uestr||$tagstr) {
         $query_url_id="SELECT $sql_small
                               dict.url_id,
                               sum(dict.intag) as r 
                          FROM url,dict 
     	                 WHERE url.rec_id=dict.url_id 
     	                   $ulstr
                           $uestr
     	                   $tagstr 
     	                   AND dict.word in ($w) 
     	                 GROUP BY url_id 
     	             HAVING ($qu)
     	              ORDER BY r DESC";
   
         $query_count_url_id="SELECT count(*)
                                FROM (
                                   SELECT dict.url_id
                                     FROM url,dict 
              	                    WHERE url.rec_id=dict.url_id 
              	                      $ulstr
                                      $uestr
              	                      $tagstr 
              	                      AND dict.word in ($w) 
              	                    GROUP BY dict.url_id
              	                   HAVING ($qu)
                                )";
      } else {
         $query_url_id="SELECT $sql_small
                               dict.url_id,
                               sum(dict.intag) as r 
     	                  FROM dict 
     	                 WHERE dict.word in ($w) 
     	                 GROUP BY url_id 
     	                HAVING ($qu)
     	                 ORDER BY r DESC";
   
         $query_count_url_id="SELECT count(*)
                                FROM (
     	                           SELECT dict.url_id
     	                             FROM dict 
     	                            WHERE dict.word in ($w)
     	                            GROUP BY dict.url_id 
     	                           HAVING ($qu)
     	                        )";
      }
   }

   $query_url="SELECT $sql_small
                      url.url,
                      url.title,
      	              url.txt,
      	              url.content_type,
      	              url.docsize,
      	              url.last_modified,
      	              url.keywords,
      	              url.description,
      	              url.crc,
      	              url.rec_id
                 FROM url
                WHERE url.rec_id = %URL_IN%";

   return array($query_url_id,$query_url,$query_count_url_id);
}


?>

