/* Unix/Windows specific stuff */

#ifndef _UDM_OS_H
#define _UDM_OS_H

#if (WIN32|WINNT)
#include <windows.h>
#include "strcasecmp.h"	/* Windows has no built-in strcasecmp, use own one */
#define mode_t int	/* mode_t is UNIX related, does not matter for MS  */
#define __INDLIB__ __declspec(dllexport) /* export functions for DLL       */

#define UDMSLASH		'\\'
#define UDMSLEEP(x)		_sleep(x*1000)
#define UDMFLASH(x)
#define UDMMEMZERO(a,b)		memset(a,0,b)
#define DUMP(x)
#define SHOWSTAT(h,a,b,c,d)	if(StatInfo)StatInfo(h,a,b,c,d)
#define REFERERINFO(h,x)
#define DELETEINFO(h,x)
#define IMPORTINFO(h,x)
#ifdef _CONSOLE
#define THREADINFO(h,s,m)       printf("Thread: %d %s %s\n", h,s,m)
#else
#define THREADINFO(h,s,m)       if(ThreadInfo)ThreadInfo(h,s,m)
#endif

extern void (*ThreadInfo)(int handle,char *state, char* str);
extern void (*StatInfo)(int handle, int code, int expired, int total, char* str);
extern __INDLIB__ int SetThreadInfo(void (*_ThreadInfo)(int handle,char *state, char* str));
extern __INDLIB__ int SetStatInfo(void (*_StatInfo)(int handle,int code, int expired, int total, char* str));

#else

#define __INDLIB__
#define UDMSLASH		'/'
#define UDMSLEEP(x)    		sleep(x)
#define DUMP(x)			printf("%s;\n",x)
#define REFERERINFO(h,x)	printf("%s\n",x)
#define SHOWSTAT(h,a,b,c,d)	printf("%10d %10d %10d %s\n",a,b,c,d)
#define DELETEINFO(h,x)		printf("%s records\r",x)
#define IMPORTINFO(h,x)		printf("%s\n",x)
#define THREADINFO(h,s,m)	/*printf("THR_INF: %d '%s' '%s'\n",h,s,m);*/
#define UDMFLASH(x)		fflush(x)
#define UDMMEMZERO(a,b)		bzero(a,b)

#endif

#endif /* _UDM_OS_H */
