#include <stdio.h>
#include <stdlib.h>

#include "udm_config.h"
#include "udm_common.h"
#include "udm_mutex.h"


#ifdef HAVE_PTHREAD
#if (WIN32|WINNT)
CRITICAL_SECTION robots_mutex;
CRITICAL_SECTION hrefs_mutex;
CRITICAL_SECTION docs_mutex;
CRITICAL_SECTION target_mutex;
CRITICAL_SECTION indexed_mutex;
CRITICAL_SECTION query_mutex;
#else
pthread_mutex_t robots_mutex;
pthread_mutex_t hrefs_mutex;
pthread_mutex_t docs_mutex;
pthread_mutex_t target_mutex;
pthread_mutex_t indexed_mutex;
pthread_mutex_t query_mutex;
pthread_mutex_t host_mutex;
#endif

__INDLIB__ int InitMutexes(){
#if (WIN32|WINNT)
	InitializeCriticalSection(&robots_mutex);
	InitializeCriticalSection(&hrefs_mutex);
	InitializeCriticalSection(&docs_mutex);
	InitializeCriticalSection(&target_mutex);
	InitializeCriticalSection(&indexed_mutex);
	InitializeCriticalSection(&query_mutex);
#else
	pthread_mutex_init(&robots_mutex,NULL);
	pthread_mutex_init(&hrefs_mutex,NULL);
	pthread_mutex_init(&docs_mutex,NULL);
	pthread_mutex_init(&target_mutex,NULL);
	pthread_mutex_init(&indexed_mutex,NULL);
	pthread_mutex_init(&host_mutex,NULL);
	pthread_mutex_init(&query_mutex,NULL);
#endif
	return(0);
}

__INDLIB__ int DestroyMutexes(){
#if (WIN32|WINNT)
	DeleteCriticalSection(&robots_mutex);
	DeleteCriticalSection(&hrefs_mutex);
	DeleteCriticalSection(&docs_mutex);
	DeleteCriticalSection(&target_mutex);
	DeleteCriticalSection(&indexed_mutex);
	DeleteCriticalSection(&query_mutex);
#else
	pthread_mutex_destroy(&robots_mutex);
	pthread_mutex_destroy(&hrefs_mutex);
	pthread_mutex_destroy(&docs_mutex);
	pthread_mutex_destroy(&target_mutex);
	pthread_mutex_destroy(&indexed_mutex);
	pthread_mutex_destroy(&host_mutex);
	pthread_mutex_destroy(&query_mutex);
#endif
	return(0);
}

#endif
