#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <ctype.h>

#include "udm_config.h"
#include "udmsearch.h"

#define T_UNKNOWN	0
#define T_TOP		1
#define T_BOT		2
#define T_RESTOP	3
#define T_RESBOT	4
#define T_RESULT	5
#define T_ERROR		6
#define T_NOTFOUND	7
#define T_CLONE		8
#define T_NAVIGATOR	9
#define T_NAVLEFT	10
#define T_NAVBAR0	11
#define T_NAVBAR1	12
#define T_NAVRIGHT	13

#define DEFAULT_PS	20

typedef struct var_struct{
	char *name;
	char *value;
} TVAR;

typedef struct template_struct{
	int where;
	char *str;
} TEMPLATE;

#define MAXTEMPLATE 1024
static TEMPLATE Template[MAXTEMPLATE];
static int ntempl=0;
static void * db;

#define MAXVARIABLE	32
TVAR Variables[MAXVARIABLE];
int nVar=0;

#define MAXRANDOM 128
int Randoms[MAXRANDOM];


/* Template variables */
static char error[BUFSIZ]="";
static char wordinfo[UDMSTRSIZ]="";
static char href[UDMSTRSIZ]="";
static char fullhref[UDMSTRSIZ]="";
static char *query_form_escaped=0;
static char *crc=0;
static char self[UDMSTRSIZ]="";
static char *title=0;
static char *text=0;
static int  size=0;
static int  rating=0;
static char *descr=0;
static char *keywords=0;
static int  url_id,docnum,first=0,last=0,found=0;
static int num_pages=0, navpage=0, ps=0, pps=10,np=0,is_next=0;
static char *mode=NULL;
static char *sort=NULL;
static char *ul_unescaped=NULL;

int AddVariable(char *name,char *value){
	if(nVar<MAXVARIABLE){
		Variables[nVar].name=strdup(name);
		Variables[nVar].value=strdup(value);
		nVar++;
		return(0);
	}
	return(1);
}

char LightWords[UDMSTRSIZ]="";
char * hilightcpy(char *dst,char *src, char *w_list, char *start,char *stop){
char *s,*t,*word;
char real_word[64]="";

	word=s=src;
	t=dst;*t=0;
	while(*s){
		if(strchr(SEPARATOR,*s)||!(*(s+1))){
			
			if(word<s){
				char save=0;
				if(*(s+1)){
					save=*s;
					*s=0;
				}
				real_word[0]=' ';
				strncpy(real_word+1,word,sizeof(real_word)-3);
				strcpy(real_word+strlen(real_word)," ");
				tolower_string(real_word,LCindex);
				if(strstr(w_list,real_word)){
					sprintf(t,"%s%s%s",start,word,stop);
					t=t+strlen(t);
				}else{
					strcpy(t,word);
					t+=strlen(word);
				}
				if(*(s+1)){
					*s=save;
				}
			}
			if(*(s+1)){
				*t=*s;
				t++;
				*t=0;
			}
			word=s+1;
		}
		s++;
	}
	return(dst);
}

int PrintTemplate(char * Target,int where,char *url,char *content_type,char *last_modified);

static int PrintOneTemplate(char * Target,char *s,int where,char *url,char *content_type,char *last_modified){
UDM_DOCUMENT *r=NULL;
int rnum,tmp;

	*Target=0;
	while(*s){
		if((*s=='\\')&&(*(s+1)=='$')){
			sprintf(UDM_STREND(Target),"$");
			s+=2;
			continue;
		}
		if(*s!='$'){
			sprintf(UDM_STREND(Target),"%c",*s);
			s++;
			continue;
		}
		
		s++;
		switch(*s){
		case 'A': sprintf(UDM_STREND(Target),"%s",self);break;
		case 'Q': sprintf(UDM_STREND(Target),"%s",query_form_escaped?query_form_escaped:"");break;
		case 'E': sprintf(UDM_STREND(Target),"%s",error);break;
		case 'W': sprintf(UDM_STREND(Target),"%s",wordinfo);break;
		case 'f': sprintf(UDM_STREND(Target),"%d",first);break;
		case 'l': sprintf(UDM_STREND(Target),"%d",last);break;
		case 't': sprintf(UDM_STREND(Target),"%d",found);break;
		case 'm': sprintf(UDM_STREND(Target),"%s",mode?mode:"all");break;
		case 's': sprintf(UDM_STREND(Target),"%s",sort?sort:"rate");break;

		case 'r': {
			s++;
			rnum=atoi(s);
			if((rnum>=0)&&(rnum<MAXRANDOM))
				sprintf(UDM_STREND(Target),"%d",Randoms[rnum]);
			while((*s)&&(isdigit(*(s+1))))
				s++;
			break;
		}
		case 'V': {
			if(num_pages>1)
				PrintTemplate(UDM_STREND(Target),T_NAVIGATOR,"","","");
			break;
		}
		case 'D':
			s++;
			switch(*s){
			case 'U':sprintf(UDM_STREND(Target),"%s",url?url:"");break;
			case 'C':sprintf(UDM_STREND(Target),"%s",content_type?content_type:"");break;
			case 'M':sprintf(UDM_STREND(Target),"%s",last_modified?last_modified:"");break;
			case 'R':sprintf(UDM_STREND(Target),"%d",rating);break;
			case 'S':sprintf(UDM_STREND(Target),"%d",size);break;
			case 'N':sprintf(UDM_STREND(Target),"%d",docnum);break;

			case 'D':hilightcpy(UDM_STREND(Target),descr    ,LightWords,"<b>","</b>");break;
			case 'T':hilightcpy(UDM_STREND(Target),title    ,LightWords,"<b>","</b>");break;
			case 'K':hilightcpy(UDM_STREND(Target),keywords ,LightWords,"<b>","</b>");break;
			case 'X':hilightcpy(UDM_STREND(Target),text     ,LightWords,"<b>","</b>");break;

			default :sprintf(UDM_STREND(Target),"%c",*s);
			}
			break;

		case 'C':
			s++;
			switch(*s){
			case 'L':
			if((crc)&&(*crc)&&(where==T_RESULT)){
				if((r=CloneList(db,crc))){
					while(r->url_id){
						if(r->url_id!=url_id)
						PrintTemplate(UDM_STREND(Target),T_CLONE,r->url,r->content_type,r->last_modified);
						r++;
					}
				}
			}
			break;
			default : sprintf(UDM_STREND(Target),"%c",*s);
			}
			break;
		case 'N':
			s++;
			switch(*s){
				case 'L':
				if (np > 0) {
					if(np>1)sprintf(fullhref,"%s&np=%d",href,np-1);
					else strcpy(fullhref,href);
					PrintTemplate(UDM_STREND(Target),T_NAVLEFT,"","","");
				}
				break;
				case 'B':
				for(navpage = 1; navpage <= num_pages;navpage++){
					tmp = np + 1 - pps/2;
					if (tmp < 1) tmp = 1;
					if (tmp > num_pages - pps + 1)
					tmp = num_pages - pps + 1;
					if (navpage >= tmp && navpage <(tmp+pps)){
						if(navpage>1)sprintf(fullhref,"%s&np=%d",href,navpage-1);
						else strcpy(fullhref,href);
						if (np == navpage-1)
						PrintTemplate(UDM_STREND(Target),T_NAVBAR0,"","","");
					else
						PrintTemplate(UDM_STREND(Target),T_NAVBAR1,"","","");
					}
				}
			break;
				case 'R':
				if (is_next) {
					sprintf(fullhref,"%s&np=%d",href,np+1);
					PrintTemplate(UDM_STREND(Target),T_NAVRIGHT,"","","");
				}
				break;
				case 'H': sprintf(UDM_STREND(Target),"%s",fullhref);break;
				case 'P': sprintf(UDM_STREND(Target),"%d",navpage);break;
			}
			break;
		default: 
			if(!strncmp(s,"ps",2)){
				sprintf(UDM_STREND(Target),"%d",ps?ps:DEFAULT_PS);
				s++;
			}else
			if(!strncmp(s,"ul",2)){
				sprintf(UDM_STREND(Target),"%s",ul_unescaped?ul_unescaped:"");
				s++;
			}else
			sprintf(UDM_STREND(Target),"%c",*s);
		}
		s++;
	}
	return(0);
}

static int PrintOption(char * Target,int where,char * option){
UDM_TAG tag;
char *s;
int len;
char tmp[UDMSTRSIZ]="";

	if(!(s=strchr(option,'>'))){
		sprintf(UDM_STREND(Target),"%s",option);
		return(0);
	}
	len=s-option;
	s=strdup(option);
	s[len+1]=0;
	parsetag(&tag,s);
	if(tag.selected&&tag.value){
		int i;
		char *value;
		PrintOneTemplate(tmp,option,where,"","","");
		freetag(&tag);
		parsetag(&tag,tmp);
		value=tag.selected?tag.selected:"";
		if(*value=='$'){
			for(i=0;i<nVar;i++){

				if(!strcmp(Variables[i].name,"ul")&&
					!strcmp(Variables[i].value,tag.value)){
					value=Variables[i].value;
					break;
				}
			}
		}
		sprintf(UDM_STREND(Target),"<OPTION VALUE=\"%s\"%s>",tag.value,
			strcmp(tag.value,value)?"":" SELECTED");
		PrintOneTemplate(UDM_STREND(Target),option+len+1,where,"","","");
	}else{	
		sprintf(UDM_STREND(Target),"%s",option);
	}
	freetag(&tag);
	return(0);
}


int PrintTemplate(char * Target,int where,char *url,char *content_type,char *last_modified){
int i;
	*Target=0;
	for(i=0;i<ntempl;i++){
		if(Template[i].where!=where)continue;
		if(!UDM_STRNCASECMP(Template[i].str,"<OPTION")){
			PrintOption(UDM_STREND(Target),where,Template[i].str);
			continue;
		}
		PrintOneTemplate(UDM_STREND(Target),Template[i].str,where,url,content_type,last_modified);
	}
	return(0);
}


int LoadTemplate(char *name, char *query){
FILE *file;
int where=0,variables=0;
char *s,*lasttok=NULL;
char str[BUFSIZ];
char first_letters[64]="";

	file=fopen(name,"r");
	if(!file)return(1);

	while((fgets(str,sizeof(str),file))&&(ntempl<MAXTEMPLATE)){
		if(!UDM_STRNCMP(str,"<!--top-->"))		where=T_TOP;
		else
		if(!UDM_STRNCMP(str,"<!--bottom-->"))	where=T_BOT;
		else
		if(!UDM_STRNCMP(str,"<!--restop-->"))	where=T_RESTOP;
		else
		if(!UDM_STRNCMP(str,"<!--resbot-->"))	where=T_RESBOT;
		else
		if(!UDM_STRNCMP(str,"<!--res-->"))		where=T_RESULT;
		else
		if(!UDM_STRNCMP(str,"<!--notfound-->"))	where=T_NOTFOUND;
		else
		if(!UDM_STRNCMP(str,"<!--error-->"))	where=T_ERROR;
		else
		if(!UDM_STRNCMP(str,"<!--clone-->"))	where=T_CLONE;
		else
		if(!UDM_STRNCMP(str,"<!--navigator-->"))	where=T_NAVIGATOR;
		else
		if(!UDM_STRNCMP(str,"<!--navleft-->"))	where=T_NAVLEFT;
		else
		if(!UDM_STRNCMP(str,"<!--navbar1-->"))	where=T_NAVBAR1;
		else
		if(!UDM_STRNCMP(str,"<!--navbar0-->"))	where=T_NAVBAR0;
		else
		if(!UDM_STRNCMP(str,"<!--navright-->"))	where=T_NAVRIGHT;
		else
		if(!UDM_STRNCMP(str,"<!--/top-->"))		where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/bottom-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/restop-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/resbot-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/res-->"))		where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/notfound-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/error-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/clone-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--variables")){	where=0;variables=1;}
		else
		if(!UDM_STRNCMP(str,"<!--/navigator-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/navleft-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/navbar1-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/navbar0-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"<!--/navright-->"))	where=0;
		else
		if(!UDM_STRNCMP(str,"-->")){	
			if(variables){
				where=0;
				variables=0;
			}
		}else{
			if(where){
				Template[ntempl].where=where;
				Template[ntempl].str=strdup(str);
				ntempl++;
			}
			if((variables)&&(s=gettoken(str,"\r\n",&lasttok))){
				if(!UDM_STRNCASECMP(str,"DBHost"))
					DBHost=strdup(trim_chars(str+6,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"DBName"))
					DBName=strdup(trim_chars(str+6,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"DBUser"))
					DBUser=strdup(trim_chars(str+6,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"DBPass"))
					DBPass=strdup(trim_chars(str+6,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"DBPort"))
					DBPort=atoi(trim_chars(str+6,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"DBMode")){
					char str1[100];
					if(sscanf(str+6,"%s",str1)){
						if(!UDM_STRNCASECMP(str1,"single"))DBMode=UDM_DBMODE_SINGLE;
						else
						if(!UDM_STRNCASECMP(str1,"crc"))DBMode=UDM_DBMODE_SINGLE_CRC;
						else
						if(!UDM_STRNCASECMP(str1,"multi"))DBMode=UDM_DBMODE_MULTI;
						else
							DBType = UDM_DBMODE_SINGLE;
					}else{
							DBType = UDM_DBMODE_SINGLE;
					}
				}else
				if(!UDM_STRNCASECMP(str,"ResultsPerPage"))
					ps=atoi(trim_chars(str+14,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"PagesPerScreen"))
					pps=atoi(trim_chars(str+14,"= \t\r\n"));
				else
				if(!UDM_STRNCASECMP(str,"LocalCharset")){
					LCindex=getcharset(trim_chars(str+12,"= \r\t\n"));
					makeseparator(SEPARATOR,LCindex);
					if(query){
						char *lasttok=NULL;
						char *w;
						tolower_string(query,LCindex);
						strcpy(str,query);
						w=gettoken(str,SEPARATOR,&lasttok);
						while(w){
							int len;
							len=strlen(first_letters);
							first_letters[len]=w[0];
							first_letters[len+1]=0;
							w=gettoken(NULL,SEPARATOR,&lasttok);
						}
					}
				}else
				if(!UDM_STRNCASECMP(str,"R")){
					int i,j;
					float frand;
					i=atoi(str+1);
			                s=str+1;
			                while((*s)&&(isdigit(*s)))
				        	s++;
					j=atoi(trim_chars(s,"= \t\r\n"));
					if((i>0)&&(i<MAXRANDOM)){
						frand=rand();
						frand=frand/RAND_MAX*j;
						Randoms[i]=frand;
					}
				}else
				if(!UDM_STRNCASECMP(str,"Affix")){
					char lang[20]="";char str1[UDMSTRSIZ]="";
					if(query)
					if(sscanf(str+5,"%s%s",lang,str1)){
						if(*str1=='/')strcpy(str,str1);
						else	sprintf(str,"%s/%s",UDM_CONF_DIR,str1);
						ImportAffixes(lang,str);
					}
				}else
				if(!UDM_STRNCASECMP(str,"Spell")){
				char lang[20]=""; char str1[UDMSTRSIZ]="";
					if(query)
					if(sscanf(str+5,"%s%s",lang,str1)){
						if(*str1=='/')strcpy(str,str1);
						else	sprintf(str,"%s/%s",UDM_CONF_DIR,str1);
						ImportDictionary(lang,str,1,first_letters);
					}
				}
			}
		}
	}
	fclose(file);
	if(query){
		if(!LCindex){
			makeseparator(SEPARATOR,LCindex);
			tolower_string(query,LCindex);
		}
		SortDictionary();
	}
	return(0);
}


int main(int argc, char **argv) {
time_t tclock;
char str[UDMSTRSIZ]="";
char str1[UDMSTRSIZ]="";
char template[UDMSTRSIZ]="";
char query_string[UDMSTRSIZ]="";
char ul_str[UDMSTRSIZ]="";
char *q=NULL,*ul=NULL,*tagstr=NULL,*sq=NULL;
char *env,*s;
int i,sort_order=UDM_ORD_RATE;
int search_mode=UDM_MOD_ALL;
char *lasttok=NULL;

UDM_DOCUMENT * r=NULL, * r1=NULL;
char Target[UDMSTRSIZ*16]="";


	/* Determine self and template name */
	if((env=getenv("UDMSEARCH_TEMPLATE")))
		strcpy(template,env);

	if((env=getenv("QUERY_STRING"))){
		strcpy(query_string,env);
		printf("Content-type: text/html\r\n\r\n");
		

		if((env=getenv("REDIRECT_STATUS"))){
			env=getenv("REDIRECT_URL");
			strcpy(self,env?env:"search.cgi");
			if(!template[0]){
				env=getenv("PATH_TRANSLATED");
				strcpy(template,env?env:"");
			}
		}else{
			env=getenv("SCRIPT_NAME");
			strcpy(self,env?env:"search.cgi");

			if(!template[0]){
				if(strcmp(UDM_CONF_DIR,".")){
					sprintf(template,"%s/%s", UDM_CONF_DIR,(s=strrchr(self,UDMSLASH))?(s+1):(self));
				}else{
					env=getenv("SCRIPT_FILENAME");
					strcpy(template,env?env:"search.cgi");
				}
				if((s=strrchr(template,'.'))){
					*s=0;strcat(template,".htm");
				}else{
					strcpy(template,"search.htm");
				}
			}
		}
	}else{
		if(argv[1])
			sprintf(query_string,"q=%s",argv[1]);
		if(!template[0])
			sprintf(template,"%s/%s", UDM_CONF_DIR,"search.htm");
	}


	/* Parse Query String */
	s=gettoken(query_string,"&",&lasttok);
	while(s){
		if(!UDM_STRNCMP(s,"q=")){
			q=strdup(UnescapeCGIQuery(str,s+2));
			sq=strdup(EscapeURL(str,q));
			query_form_escaped=strdup(EscapeHtml(str,q,'"'));
		}else
		if(!UDM_STRNCMP(s,"np="))np=atoi(s+3);
		else
		if(!UDM_STRNCMP(s,"ps="))ps=atoi(s+3);
		else
		if(!UDM_STRNCMP(s,"ul=") && strlen(s) > 3){

#ifdef HAVE_FILES
#undef USE_AUTO_WILD
#endif

#ifdef USE_AUTO_WILD
			sprintf(str1,"%%%s%%",UnescapeCGIQuery(str,s+3));
#else
			sprintf(str1,"%s",UnescapeCGIQuery(str,s+3));
#endif
			AddVariable("ul",str);
			UDM_FREE(ul_unescaped);
			ul_unescaped=strdup(str);
			AddURLLimit(str1);
			ul=strdup(s+3);
			sprintf(UDM_STREND(ul_str),"&ul=%s",ul);
		}else
		if((!UDM_STRNCMP(s,"t="))&&(*(s+2))){
			AddTagLimit(atoi(s+2));
		}else
		if(!UDM_STRNCMP(s,"m=")){
			mode=s+2;
			if(!strcmp(mode,"all"))search_mode=UDM_MOD_ALL;
			if(!strcmp(mode,"any"))search_mode=UDM_MOD_ANY;
		}else
		if(!UDM_STRNCMP(s,"s=")){
			sort=s+2;
			if(!strcmp(sort,"date"))sort_order=UDM_ORD_DATE;
			if(!strcmp(sort,"rate"))sort_order=UDM_ORD_RATE;
		}
		s=gettoken(NULL,"&",&lasttok);
	}

	tclock=time(0);srand(tclock);
	for(i=0;i<MAXRANDOM;i++)Randoms[i]=0;

	InitCharset();
	db=AllocDB(UDM_OPEN_MODE_READ);

	if(LoadTemplate(template,q)){
		printf("<html><body>Can't open template file '%s'!</body></html>\n",template);
		return(0);
	}

	PrintTemplate(Target,T_TOP,"","","");printf("%s",Target);

	if(!q){
		PrintTemplate(Target,T_BOT,"","","");printf("%s",Target);
		exit(0);
	}


#ifdef HAVE_PTHREAD
	InitMutexes();
#endif

	strcpy(str,q);
	s=gettoken(str,SEPARATOR,&lasttok);
	while(s){
		sprintf(UDM_STREND(LightWords)," %s ",s);
		s=gettoken(NULL,SEPARATOR,&lasttok);
	}

	if((r=Find(db,q,np,ps?ps:DEFAULT_PS,search_mode,sort_order,wordinfo,&found))){
		last=first=docnum=(ps?ps:DEFAULT_PS)*np+1;
		r1=r;while((++r1)->url_id)last++;
		num_pages = found/(ps?ps:DEFAULT_PS);
		is_next=last<found;
		if((ps?ps:DEFAULT_PS)*num_pages<found)num_pages++;

		PrintTemplate(Target,T_RESTOP,"","","");printf("%s",Target);
		sprintf(href,"%s?q=%s",self,sq);

		if(tagstr)sprintf(UDM_STREND(href),"&t=%s",tagstr);
		//if(ul)sprintf(UDM_STREND(href),"&ul=%s",ul);
		strcpy(UDM_STREND(href),ul_str);
		if(mode)sprintf(UDM_STREND(href),"&m=%s",mode);
		if(sort)sprintf(UDM_STREND(href),"&s=%s",sort);
		if(ps)sprintf(UDM_STREND(href),"&ps=%d",ps);

		while(r->url_id){
			url_id=r->url_id;
			title=HtmlSpecialChars(r->title);
			text=HtmlSpecialChars(r->text);
			size=r->size;
			rating=r->rating;
			descr=HtmlSpecialChars(r->description);
			keywords=HtmlSpecialChars(r->keywords);
			crc=r->crc;
			PrintTemplate(Target,T_RESULT,r->url,r->content_type,r->last_modified);
			printf("%s",Target);
			UDM_FREE(title);
			UDM_FREE(text);
			UDM_FREE(descr);
			UDM_FREE(keywords);
			r++;docnum++;
		}
		PrintTemplate(Target,T_RESBOT,"","","");printf("%s",Target);
	}else{
		if(DBErrorCode(db)){
			strcpy(error,DBErrorMsg(db));
			PrintTemplate(Target,T_ERROR,"","","");printf("%s",Target);
		}else{
			PrintTemplate(Target,T_NOTFOUND,"","","");printf("%s",Target);
		}
	}
	PrintTemplate(Target,T_BOT,"","","");printf("%s",Target);
	FreeDB(db);

#ifdef HAVE_PTHREAD
	DestroyMutexes();
#endif
	return(0);
}
